package verschiebeSpiel;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

public class ListenerButton implements ActionListener {
	Logik logik;
	private Spielfeld spielfeld;

	public ListenerButton(Logik logik) {
		this.logik = logik;
	}

	public void actionPerformed(ActionEvent event) {
		JButton source = (JButton)event.getSource();
		
		// ergiebt JFrame,
		// view = (View)(source.getParent().getParent().getParent().getParent().getParent());		
		// ergibt Class View
		spielfeld = (Spielfeld)(source.getParent());
		
		// Parents:1-View,2-JPanel,3-JLayerdPane,4-JRootPane,5-JFrame
		// System.out.print(source.getParent().getClass());

		/** Verschiebe Spielstein. Bei Fehler BEEP */
		if (logik.move(event.getActionCommand())) {
			/** Falls gewonnen, zeige Dialog an */
			if (logik.richtigeReihenfolge()) {
				int yes = JOptionPane.showConfirmDialog(spielfeld,
				                                        "Neues Spiel?",
				                                        "Hurra Gewonnen!", 
				                                        JOptionPane.YES_NO_OPTION);
				if (yes == JOptionPane.YES_OPTION) {
					Hauptfenster hf = (Hauptfenster)source.getTopLevelAncestor();
					hf.startNewGame();
				}
			}
			
			spielfeld.zeichneFeld();
		} else {
			Toolkit.getDefaultToolkit().beep(); // Audio Beep
		}
	}
}
