package verschiebeSpiel;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.JButton;

public class ListenerNewGame implements ActionListener {
	
	/**
	 * Event-Handler fuer "Neues Spiel"-Button im <code>Navigator</code>-Fenster.
	 * Ermittelt ber die Fenster-Hierarchie das Hauptfenster und teilt diesem mit,
	 * ein neues Spiel zu starten.
	 */
	@Override
	public void actionPerformed(ActionEvent event) {
		JButton source = (JButton)event.getSource();
		Hauptfenster hf = (Hauptfenster)(source.getTopLevelAncestor().getParent());
		
		hf.startNewGame();
	}

}
