package verschiebeSpiel;

import java.util.*;

public class Logik {
	
	private static int counter = 0;
	
	private int numbers[] = {0,1,2,3,4,5,6,7,8};
	
	Random generator = new Random(8);
	
	public Logik(){
		/** Temp Variable f?r das setzen der 0 an das Ende */
		int tmp;
		
		/** Mischen des Arrays */
		for(int i=0;i<numbers.length;i++) {
			int j=(int)(numbers.length*Math.random());
		    int dummy=numbers[i];
		    numbers[i]=numbers[j];
		    numbers[j]=dummy;
		}
		
		/** Setzen der Null an das Ende */
		for(int i=0; i<9; i++){
			if(numbers[i] == 0){
				tmp = numbers[8];
				numbers[8] = numbers[i];
				numbers[i] = tmp;
				return;
			}
		}
	}
	
	/** Rueckgabe des Integer Arrays als String Array */
	public java.lang.String[] getNummern(){
		String nummern[] = new String[9];
		
		for(int i=0;i<9;i++){
			nummern[i] = String.valueOf(numbers[i]);
		}
		
		return nummern;
	}
	
	/** Rueckgabe wieviele Zuege gebraucht wurden */
	public int getZaehler(){
		return counter;
	}
	
	/** Bewegen der Felder */
	public boolean move(java.lang.String ziffer){
		int tmp = 0;
		boolean result = false;
		// Holen der aktuellen Zahlenreihenfolge
		String zahlen[] = getNummern();
		// Aktueller Ort im Array
		int loc = 0;
		
		// Abrufen, an welcher stelle im Array sich die zu bewegende Zahl befindet
		for(int i=0; i<9; i++){
			if(zahlen[i].contains(ziffer)){
				loc = i;
			}
		}
		//Verschieben der Zahlen
		if(loc != 0){
			if(numbers[loc-1] == 0){
				tmp = numbers[loc-1];
				numbers[loc-1] = numbers[loc];
				numbers[loc] = tmp;
				counter = counter+1;
				return true;
			}
		}
		if(loc != 8){
			if(numbers[loc + 1] == 0 && loc != 8){
				tmp = numbers[loc+1];
				numbers[loc+1] = numbers[loc];
				numbers[loc] = tmp;
				counter = counter+1;
				return true;
			}
		}
		if(loc>2){
			if(numbers[loc-3] == 0 && loc>2 ){
				tmp = numbers[loc-3];
				numbers[loc-3] = numbers[loc];
				numbers[loc] = tmp;
				counter = counter+1;
				return true;
			}
		}
		if(loc<6){
			if(numbers[loc+3] == 0 && loc<6){
				tmp = numbers[loc+3];
				numbers[loc+3] = numbers[loc];
				numbers[loc] = tmp;
				counter = counter+1;
				return true;
			}
		}
		return result;
	}
	
	public boolean richtigeReihenfolge(){
					
		// Holen der aktuellen Reihenfolge
		String nummern[] = getNummern();
		
		// Vorgegebene Reihenfolge
		String num_right[] = {"1","2","3","4","5","6","7","8","0"};
		
		// Wenn Reihenfolge gleich, R?ckgabe true sonst false
		return Arrays.equals(nummern,num_right);
	}
}
